<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/ryu-1.0.10/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../ryu/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../ryu/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../ryu/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
</pre><pre class="rust"><code><span class="doccomment">//! [![github]](https://github.com/dtolnay/ryu)&amp;ensp;[![crates-io]](https://crates.io/crates/ryu)&amp;ensp;[![docs-rs]](https://docs.rs/ryu)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [github]: https://img.shields.io/badge/github-8da0cb?style=for-the-badge&amp;labelColor=555555&amp;logo=github</span>
<span class="doccomment">//! [crates-io]: https://img.shields.io/badge/crates.io-fc8d62?style=for-the-badge&amp;labelColor=555555&amp;logo=rust</span>
<span class="doccomment">//! [docs-rs]: https://img.shields.io/badge/docs.rs-66c2a5?style=for-the-badge&amp;labelColor=555555&amp;logoColor=white&amp;logo=data:image/svg+xml;base64,PHN2ZyByb2xlPSJpbWciIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgdmlld0JveD0iMCAwIDUxMiA1MTIiPjxwYXRoIGZpbGw9IiNmNWY1ZjUiIGQ9Ik00ODguNiAyNTAuMkwzOTIgMjE0VjEwNS41YzAtMTUtOS4zLTI4LjQtMjMuNC0zMy43bC0xMDAtMzcuNWMtOC4xLTMuMS0xNy4xLTMuMS0yNS4zIDBsLTEwMCAzNy41Yy0xNC4xIDUuMy0yMy40IDE4LjctMjMuNCAzMy43VjIxNGwtOTYuNiAzNi4yQzkuMyAyNTUuNSAwIDI2OC45IDAgMjgzLjlWMzk0YzAgMTMuNiA3LjcgMjYuMSAxOS45IDMyLjJsMTAwIDUwYzEwLjEgNS4xIDIyLjEgNS4xIDMyLjIgMGwxMDMuOS01MiAxMDMuOSA1MmMxMC4xIDUuMSAyMi4xIDUuMSAzMi4yIDBsMTAwLTUwYzEyLjItNi4xIDE5LjktMTguNiAxOS45LTMyLjJWMjgzLjljMC0xNS05LjMtMjguNC0yMy40LTMzLjd6TTM1OCAyMTQuOGwtODUgMzEuOXYtNjguMmw4NS0zN3Y3My4zek0xNTQgMTA0LjFsMTAyLTM4LjIgMTAyIDM4LjJ2LjZsLTEwMiA0MS40LTEwMi00MS40di0uNnptODQgMjkxLjFsLTg1IDQyLjV2LTc5LjFsODUtMzguOHY3NS40em0wLTExMmwtMTAyIDQxLjQtMTAyLTQxLjR2LS42bDEwMi0zOC4yIDEwMiAzOC4ydi42em0yNDAgMTEybC04NSA0Mi41di03OS4xbDg1LTM4Ljh2NzUuNHptMC0xMTJsLTEwMiA0MS40LTEwMi00MS40di0uNmwxMDItMzguMiAxMDIgMzguMnYuNnoiPjwvcGF0aD48L3N2Zz4K</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Pure Rust implementation of Ryū, an algorithm to quickly convert floating</span>
<span class="doccomment">//! point numbers to decimal strings.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The PLDI&#39;18 paper [*Ryū: fast float-to-string conversion*][paper] by Ulf</span>
<span class="doccomment">//! Adams includes a complete correctness proof of the algorithm. The paper is</span>
<span class="doccomment">//! available under the creative commons CC-BY-SA license.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This Rust implementation is a line-by-line port of Ulf Adams&#39; implementation</span>
<span class="doccomment">//! in C, [https://github.com/ulfjack/ryu][upstream].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [paper]: https://dl.acm.org/citation.cfm?id=3192369</span>
<span class="doccomment">//! [upstream]: https://github.com/ulfjack/ryu</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! fn main() {</span>
<span class="doccomment">//!     let mut buffer = ryu::Buffer::new();</span>
<span class="doccomment">//!     let printed = buffer.format(1.234);</span>
<span class="doccomment">//!     assert_eq!(printed, &quot;1.234&quot;);</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Performance (lower is better)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ![performance](https://raw.githubusercontent.com/dtolnay/ryu/master/performance.png)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! You can run upstream&#39;s benchmarks with:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```console</span>
<span class="doccomment">//! $ git clone https://github.com/ulfjack/ryu c-ryu</span>
<span class="doccomment">//! $ cd c-ryu</span>
<span class="doccomment">//! $ bazel run -c opt //ryu/benchmark</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! And the same benchmark against our implementation with:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```console</span>
<span class="doccomment">//! $ git clone https://github.com/dtolnay/ryu rust-ryu</span>
<span class="doccomment">//! $ cd rust-ryu</span>
<span class="doccomment">//! $ cargo run --example upstream_benchmark --release</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! These benchmarks measure the average time to print a 32-bit float and average</span>
<span class="doccomment">//! time to print a 64-bit float, where the inputs are distributed as uniform random</span>
<span class="doccomment">//! bit patterns 32 and 64 bits wide.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The upstream C code, the unsafe direct Rust port, and the safe pretty Rust API</span>
<span class="doccomment">//! all perform the same, taking around 21 nanoseconds to format a 32-bit float and</span>
<span class="doccomment">//! 31 nanoseconds to format a 64-bit float.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! There is also a Rust-specific benchmark comparing this implementation to the</span>
<span class="doccomment">//! standard library which you can run with:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```console</span>
<span class="doccomment">//! $ cargo bench</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The benchmark shows Ryū approximately 2-5x faster than the standard library</span>
<span class="doccomment">//! across a range of f32 and f64 inputs. Measurements are in nanoseconds per</span>
<span class="doccomment">//! iteration; smaller is better.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Formatting</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This library tends to produce more human-readable output than the standard</span>
<span class="doccomment">//! library&#39;s to\_string, which never uses scientific notation. Here are two</span>
<span class="doccomment">//! examples:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! - *ryu:* 1.23e40, *std:* 12300000000000000000000000000000000000000</span>
<span class="doccomment">//! - *ryu:* 1.23e-40, *std:* 0.000000000000000000000000000000000000000123</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Both libraries print short decimals such as 0.0000123 without scientific</span>
<span class="doccomment">//! notation.</span>

<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/ryu/1.0.10&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(
    <span class="ident">clippy::cast_lossless</span>,
    <span class="ident">clippy::cast_possible_truncation</span>,
    <span class="ident">clippy::cast_possible_wrap</span>,
    <span class="ident">clippy::cast_sign_loss</span>,
    <span class="ident">clippy::checked_conversions</span>,
    <span class="ident">clippy::doc_markdown</span>,
    <span class="ident">clippy::expl_impl_clone_on_copy</span>,
    <span class="ident">clippy::if_not_else</span>,
    <span class="ident">clippy::many_single_char_names</span>,
    <span class="ident">clippy::missing_panics_doc</span>,
    <span class="ident">clippy::module_name_repetitions</span>,
    <span class="ident">clippy::must_use_candidate</span>,
    <span class="ident">clippy::similar_names</span>,
    <span class="ident">clippy::too_many_lines</span>,
    <span class="ident">clippy::unreadable_literal</span>,
    <span class="ident">clippy::unseparated_literal_suffix</span>,
    <span class="ident">clippy::wildcard_imports</span>
)]</span>

<span class="kw">mod</span> <span class="ident">buffer</span>;
<span class="kw">mod</span> <span class="ident">common</span>;
<span class="kw">mod</span> <span class="ident">d2s</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>))]</span>
<span class="kw">mod</span> <span class="ident">d2s_full_table</span>;
<span class="kw">mod</span> <span class="ident">d2s_intrinsics</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">d2s_small_table</span>;
<span class="kw">mod</span> <span class="ident">digit_table</span>;
<span class="kw">mod</span> <span class="ident">f2s</span>;
<span class="kw">mod</span> <span class="ident">f2s_intrinsics</span>;
<span class="kw">mod</span> <span class="ident">pretty</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::buffer</span>::{<span class="ident">Buffer</span>, <span class="ident">Float</span>};

<span class="doccomment">/// Unsafe functions that mirror the API of the C implementation of Ryū.</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">raw</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::pretty</span>::{<span class="ident">format32</span>, <span class="ident">format64</span>};
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="ryu" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>